; Timing tests for mod!!

(*PROCLAIM '(TYPE (UNSIGNED-BYTE 8) fldsz))

(defparameter fldsz 32)

(*PROCLAIM '(TYPE (UNSIGNED-BYTE 24) mdls))

(defvar mdls 1)

(*PROCLAIM '(TYPE (FIELD-PVAR fldsz) A B M))

(*DEFVAR A (!! 0))
(*DEFVAR B (!! 0))
(*DEFVAR M (!! 0))

(defvar vprcs 0)    ;; Set to number of virtual processors
(defvar ops 0)    ;; Set to number of mod operations in test

; Sets up modulus timing.  Start in *Lisp package.  ATTACH FIRST!

(defun start (xs ys)
 (*cold-boot :initial-dimensions (list xs ys))
 (setq vprcs (* xs ys))
 (format t "~D virtual processors~%" vprcs)
 (demo 10)
)

(defun demo (n)
"(demo n) -- times n cycles of A := B mod mdls"
  (cm:time (demox n))
  (setq ops (* vprcs n))
)

(defun demox (n)
  (declare (type fixnum n))
  (dotimes (k n)
    (*set A  (mod!! B (!! mdls))))
)


(defun demo2 (n)
"(demo n) -- times n cycles of A := B mod M"
  (cm:time (demoy n))
  (setq ops (* vprcs n))
)

(defun demoy (n)
  (declare (type fixnum n))
  (dotimes (k n)
    (*set A  (mod!! B M)))
)
